﻿Public Class Form1

    Private KdBarang As Integer = 0         'Deklarasi KdBarang; akan digunakan saat item dalam listView dipilih..

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim msg As String = ""
        If OpenConnection(msg) Is Nothing Then          'Test koneksi ke database
            MessageBox.Show("Gagal koneksi: " & msg)
            Exit Sub
        End If

        'Tampilkan data saat pertama kali Form1 di tampilkan
        loadData()
        'Nonaktifkan tombol simpan
        cmdSimpan.Enabled = False
        'Nonaktifkan textbox
        _kunciTeks()
    End Sub

    ''' <summary>
    ''' Tampilkan semua data barang dari dalam database
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub loadData()
        'Menampilkan data dari database ke kontrol ListView LvBarang
        'Di sini kita mulai menggunakan PublicSQLBuilder
        'Deklarasikan sqlSelect sebagai Class SQLSelectBuilder
        Dim sqlSelect As New SQLSelectBuilder
        With sqlSelect
            .AddTable(tblBarang._tablename)     'Menambah tabel barang ke daftar tabel yang akan digunakan
            .AddField(tblBarang.KdBarang)       'Menambah KdBarang ke daftar Field yang akan diambil
            .AddField(tblBarang.NmBarang)       'Menambah NmBarang ke daftar Field
            .AddField(tblBarang.NoProduk)       'Menambah NoProduk ke daftar Field
            .AddField(tblBarang.Jumlah)         'Menambah Jumlah ke daftar Field
            .AddField(tblBarang.Harga)          'Menambah Harga ke daftar Field
            .AddWhere(tblBarang.Dihapus, "=", 0) 'Hanya memilih barang yang belum dihapus (Dihapus = 0)
        End With
        'Hasil dari sqlSelect pada property getsqlcommand dengan cara di atas adalah:
        'SELECT KdBarang, NmBarang, NoProduk, Jumlah, Harga from tblBarang WHERE Dihapus = 0

        Dim dv As New Data.DataView
        dv = DoSqlDataView(sqlSelect.getsqlcommand)
        If dv.Count <> 0 Then
            'Mengosongkan daftar barang dari dalam kontrol LvBarang
            LvBarang.Items.Clear()
            'Loop sampai semua data terbaca
            For i As Integer = 0 To dv.Count - 1    'Menggunakan -1 agar nilai i dan nilai index dari dv sesuai
                'Deklarasikan lv sebagai ListViewItem yang akan ditambahkan ke dalam kontrol LvBarang
                'Tambahkan setiap nilai yang didapat dari database (dalam dataview dv) ke dalam object lv
                Dim lv As New ListViewItem(CStr(dv(i)(tblBarang.KdBarang))) 'Mengambil nilai dari KdBarang pada index ke i
                With lv.SubItems
                    .Add(CStr(dv(i)(tblBarang.NoProduk)))
                    .Add(CStr(dv(i)(tblBarang.NmBarang)))
                    .Add(CStr(dv(i)(tblBarang.Jumlah)))
                    .Add(CStr(dv(i)(tblBarang.Harga)))
                End With
                'Mengisi control LvBarang dengan isi dari lv
                Me.LvBarang.Items.Add(lv)
            Next
            'Note: Nilai dari dalam object dv juga bisa dimanipulasi:
            'Total harga = CDbl(dv(i)(tblBarang.Harga)) * CDbl(dv(i)(tblBarang.Jumlah))
        End If
    End Sub

    ''' <summary>
    ''' Menambah data baru
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub tambahData()
        'Deklarasikan sqlInsert sebagai SQLInsertBuilder dari modul PublicSQLBuilder (Persiapan menambah data baru)
        Dim sqlInsert As New SQLInsertBuilder
        With sqlInsert
            .AddTable(tblBarang._tablename)                 'Nama tabel yang akan dipakai
            .AddField(tblBarang.NoProduk, TbNoBarang.Text)  'Menambah isi NoProduk dengan nilai pada TbNoBarang
            .AddField(tblBarang.NmBarang, TbNmBarang.Text)  'Menambah isi NmBarang dengan nilai pada TbNmBarang
            .AddField(tblBarang.Jumlah, TbJumlah.Text)      'Menambah isi Jumlah dengan nilai pada TbJumlah
            .AddField(tblBarang.Harga, TbHarga.Text)        'Menambah isi Harga dengan nilai pada TbHarga
        End With
        If DoSqlCommand(sqlInsert.getsqlcommand) Then       'Menjalankan perintah dari sqlInsert menggunakan DoSqlCommand
            'Nilai dari KdBarang terakhir belum bisa diketahui, untuk mengetahui nilai dari suatu field yang
            'bertipe auto increment bisa dengan menggunakan fungsi GetIdentity
            'Mengambil nilai dari KdBarang yang baru dimasukkan
            Dim KdBarangTerakhir As Integer = GetIdentity(tblBarang._tablename)
            MessageBox.Show("Data berhasil disimpan dengan kode " & KdBarangTerakhir, Me.Text)
        Else
            MessageBox.Show("Gagal menyimpan data.", Me.Text)
        End If
    End Sub

    ''' <summary>
    ''' Mengupdate data lama
    ''' </summary>
    ''' <param name="hapus">Bila Hapus = true, maka data lama akan dihapus, dan sebaliknya</param>
    ''' <remarks></remarks>
    Private Sub updateData(Optional ByVal hapus As Boolean = False)
        'Deklarasi sqlUpdate sebagai SQLUpdateBuilder (Persiapan mengupdate data lama)
        Dim sqlUpdate As New SQLUpdateBuilder
        With sqlUpdate
            .AddTable(tblBarang._tablename)                     'Nama tabel yang akan diupdate
            .AddField(tblBarang.NoProduk, TbNoBarang.Text)      'Update nilai NoProduk dengan nilai dari TbNoBarang
            .AddField(tblBarang.NmBarang, TbNmBarang.Text)      'Update nilai NmBarang dengan nilai dari TbNmBarang
            .AddField(tblBarang.Jumlah, TbJumlah.Text)          'Update nilai Jumlah dengan nilai dari TbJumlah
            .AddField(tblBarang.Harga, TbHarga.Text)            'Update nilai Harga dengan nilai dari TbHarga
            'Bila hapus bernilai TRUE, maka data akan dihapus
            If hapus Then
                .AddField(tblBarang.Dihapus, 1)
            End If
            .AddWhere(tblBarang.KdBarang, "=", Me.KdBarang)     'Kode dari barang yang akan dihapus
        End With
        If DoSqlCommand(sqlUpdate.getsqlcommand) Then           'Menjalankan perintah dari sqlUpdate menggunakan DoSqlCommand
            MessageBox.Show("Data berhasil diupdate", Me.Text)
        Else
            MessageBox.Show("Gagal mengupdate data.", Me.Text)
        End If
    End Sub

    Private _sedangEdit As Boolean = False
    ''' <summary>
    ''' Menonaktifkan textbox
    ''' </summary>
    ''' <remarks></remarks>
    Sub _kunciTeks()
        Me.TbHarga.Enabled = False
        Me.TbJumlah.Enabled = False
        Me.TbNmBarang.Enabled = False
        Me.TbNoBarang.Enabled = False
    End Sub

    ''' <summary>
    ''' Mengaktifkan textbox
    ''' </summary>
    ''' <remarks></remarks>
    Sub _bukaTeks()
        Me.TbHarga.Enabled = True
        Me.TbJumlah.Enabled = True
        Me.TbNmBarang.Enabled = True
        Me.TbNoBarang.Enabled = True
    End Sub
    ''' <summary>
    ''' Mengosongkan isi dari teksbox
    ''' </summary>
    ''' <remarks></remarks>
    Sub _resetTeks()
        Me.TbHarga.Text = ""
        Me.TbJumlah.Text = ""
        Me.TbNmBarang.Text = ""
        Me.TbNoBarang.Text = ""
    End Sub

    Private Sub cmdSimpan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSimpan.Click
        'Jika tidak sedang dalam kondisi Edit maka panggil prosedur tambahData, dan sebaliknya
        If _sedangEdit = False Then
            tambahData()
        Else
            updateData()
        End If

        cmdSimpan.Enabled = False   'Nonaktifkan tombol simpan
        cmdEdit.Enabled = True      'Aktifkan tombol edit
        cmdHapus.Enabled = True     'Aktifkan tombol hapus
        cmdBaru.Text = "Baru"       'Ubah text dari tombol Baru ke "Baru"
        _resetTeks()                'Kosongkan textbox
        _kunciTeks()                'Nonaktifkan textbox
        loadData()                  'Isi ulang LvBarang untuk melihat perubahan
    End Sub

    Private Sub cmdBaru_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBaru.Click
        _sedangEdit = False             'Ini bukan proses edit
        _resetTeks()                    'Kosongkan textbox
        KdBarang = 0                    'Pastikan nilai pada variabel KdBarang = 0
        If cmdBaru.Text = "Baru" Then   'Jika text cmdBaru = Baru
            cmdSimpan.Enabled = True    'Aktifkan cmdSimpan
            cmdEdit.Enabled = False     'Nonaktifkan cmdEdit
            cmdHapus.Enabled = False    'Nonaktifkan cmdHapus
            cmdBaru.Text = "Batal"      'Ubah text cmdBaru menjadi Batal
            KdBarang = 0
            _bukaTeks()                 'Aktifkan Textbox
        Else                            'Jika text pada cmdBaru = Batal
            cmdBaru.Text = "Baru"       'Ubah text pada cmdBaru menjadi Baru
            cmdSimpan.Enabled = False   'Nonaktifkan cmdSimpan
            cmdEdit.Enabled = True      'Aktifkan cmdEdit
            cmdHapus.Enabled = True     'Aktifkan cmdHapus
            _kunciTeks()                'Nonaktifkan semua textbox
        End If
    End Sub

    Private Sub LvBarang_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LvBarang.Click
        'Validasi: apakah di dalam kontrol LvBarang terdapat barang? Jika tidak ada, keluar dari Sub
        If LvBarang.Items.Count = 0 Then
            Exit Sub
        End If

        'Jika tidak ada barang yang dipilih, tampilkan pesan
        If LvBarang.SelectedItems.Count = 0 Then
            MessageBox.Show("Data tidak tersedia.", Me.Text)
            Exit Sub
        End If

        'Mengambil nilai dari KdBarang pada suatu barang yang terdapat pada index 0 dari item yang dipilih dari dalam LvBarang
        KdBarang = CInt(LvBarang.SelectedItems(0).SubItems(0).Text)

        'Mengisi tiap textbox dengan nilai dari barang yang dipilih dalam LvBarang 
        Me.TbNoBarang.Text = LvBarang.SelectedItems(0).SubItems(1).Text
        Me.TbNmBarang.Text = LvBarang.SelectedItems(0).SubItems(2).Text
        Me.TbJumlah.Text = LvBarang.SelectedItems(0).SubItems(3).Text
        Me.TbHarga.Text = LvBarang.SelectedItems(0).SubItems(4).Text
    End Sub

    Private Sub cmdEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEdit.Click
        If KdBarang = 0 Then    'Jika belum ada barang yang dipilih dari dalam LvBarang, maka tampilkan pesan
            MessageBox.Show("Silahkan pilih barang dari daftar.", Me.Text)
            Exit Sub
        End If
        _sedangEdit = True          'Ubah variabel _sedangEdit menjadi True
        _bukaTeks()                 'Aktifkan textbox
        cmdBaru.Text = "Batal"      'Ubah text pada cmdBaru menjadi "Batal"
        cmdSimpan.Enabled = True    'Aktifkan cmdSimpan
        cmdEdit.Enabled = False     'Nonaktifkan cmdEdit
        cmdHapus.Enabled = False    'Nonaktifkan cmdHapus
    End Sub

    Private Sub cmdHapus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHapus.Click
        'Jika tidak ada barang yang dipilih, tampilkan pesan
        If KdBarang = 0 Then
            MessageBox.Show("Tidak ada barang yang dipilih.", Me.Text)
            Exit Sub
        End If

        'Tampilkan pesan konfirmasi penghapusan data
        If MessageBox.Show("Ingin menghapus barang ini?", Me.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.No Then
            Exit Sub
        End If

        'Mulai proses penghapusan dengan memanggil prosedur updateData dengan mengatur nilai 'hapus' menjadi True
        updateData(True)
        'Kosongkan textbox
        _resetTeks()
        'Muat ulang semua data untuk melihat perubahan
        loadData()
    End Sub

    Private Sub cmdTutup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdTutup.Click
        Me.Close()  'Menutup form ini
    End Sub
End Class
